#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>

#include "ezfpga.h"

#define EZFPGA_EXTERN_CFG   0 /* ÕRtBOt@C(bit)gpꍇ͂P */

#if EZFPGA_EXTERN_CFG
const unsigned char ezfpga_bit[]="fpga\\ezfpga.bit";	//ORtBO[Vt@C
#else
#include "clkgenf.c"									//exe荞ݗpRtBO[Vf[^
#endif

#define BASE	24*1000*1000	//24MHz
#define BASEF	24.0*1000*1000	//24MHz

// C
int main(int argc,char *argv[]){
	int i,st_a;
	int a,b,min_a,min_b,div,dll;
	double f,ff,f1,f2;
	double d,min_d;
	unsigned char buf[8],instr[256],*s;

	if( ezfpga_init(DEVICE_USB2(0)))
	{
		printf("Can't found EZ-FPGA\n");
		return -1;
	}

	if(ezfpga_config_show(ezfpga_bit,sizeof(ezfpga_bit)))
	{
		printf("Can't Config EZ-FPGA\n");
		ezfpga_unlink();
		return -1;
	}

	for(;;){
		if(argc==2){
			s=argv[1];
		}
		else{
			printf("input frequency(EX. 10.2K or 66M). ");
			gets(instr);
			s=instr;
		}
		i=strlen(s)-1;
		if(i<0) break;
		switch(s[i]){
		case 'k':
		case 'K':
			f1=1000;
			s[i]=0;
			break;
		case 'm':
		case 'M':
			f1=1000*1000;
			s[i]=0;
			break;
		default:
			f1=1;
			break;
		}
		if(sscanf(s,"%lf",&f)!=1){
			printf("input format error.\n");
			goto USAGE;
		}
		f=f*f1;
		if((f<1.0)||(f>180.0*1000*1000)){
			printf("input range error.\n");
			goto USAGE;
		}
		if(f<30*1000*1000){//30MHzȉȂDivgp
			div=(int)((30*1000*1000)/f);
			div=(int)((div+1)/2*2);
			f=f*div;
		}
		else{
			div=0;
		}
		if(f>90*1000*1000){//90MHzȏȂDLLgp
			dll=1;
			f=f/2.0;
		}
		else{
			dll=0;
		}
		st_a=BASE/(1000*1000);
		min_d=1000*1000;
		for(a=st_a;a<1000;a++){
			b=(int)(f/(BASEF/a));
			f1=b*(BASEF/a);
			f2=(b+1)*(BASEF/a);
			if((f-f1)>(f2-f)){
				b=b+1;
				d=f2-f;
			}
			else{
				d=f-f1;
			}
			if(d<min_d){
				min_d=d;
				min_a=a;
				min_b=b;
			}
			if(min_d==0) break;
		}
		if((min_b>=16384)){
			printf("Fatal error. div_a=%d dib_b=%d.\n",min_a,min_b);
			return(-1);
		}

		ff=min_b*(BASEF/min_a);
		if(div){
			printf("%3.9fMHz/%d=%3.9fMHz div_a=%d div_b=%d\n",ff/1000000,div,ff/div/1000000,min_a,min_b);
		}
		else if(dll){
			printf("%3.9fMHz*2=%3.9fMHz div_a=%d div_b=%d\n",ff/1000000,ff*2/1000000,min_a,min_b);
		}
		else{
			printf("%3.9fMHz div_a=%d div_b=%d\n",ff/1000000,min_a,min_b);
		}
		printf("Error %.5f%%\n\n",(1.0-ff/f)*100);

		//div_a
		buf[0]=(min_a-1);
		buf[1]=(min_a-1)>>8;
		//div_b
		buf[2]=(min_b-1);
		buf[3]=(min_b-1)>>8;
		//div(0:/2 1:/4 2:/6 ....)
		buf[4]=(div/2-1);
		buf[5]=(div/2-1)>>8;
		buf[6]=(div/2-1)>>16;
		//sel 0:VCO 1:DIV 2:DLL2X
		if(dll){
			buf[7]=2;
		}
		else if(div){
			buf[7]=1;
		}
		else{
			buf[7]=0;
		}
		jmem_write(0,buf,8);		//PLL,Divider,DLL̃p[^FPGAɃZbg

		for(i=0;i<10;i++){
			jmem_read(0,buf,1);		//PLL,DLLbNĂ邩`FbN
			if(buf[0]==3) break;
			Sleep(100);
		}
		if(i==10){
			printf("Can't lock error!!!\n");
			ezfpga_unlink();
			return(-1);
		}
		if(argc==2) break;
	}
	//I
	ezfpga_unlink();
	return(0);
USAGE:
	ezfpga_unlink();
	printf("Ex. clkgen 10.5K    .....  10.5KHz\n");
	printf("    clkgen 12.3M    .....  12.3MHz\n");
	printf("    clkgen          .....  conversation mode.\n");
	printf("      (1.0Hz <= f <= 180MHz)\n");
	return(-1);
}

